#ifndef PLANE_H
#define PLANE_H

typedef struct
{
	vec3	normal;		// Plane normal. 
	float	d;			// The plane distance from origin 
} plane_t;

typedef enum
{
	ALL_IN,
	ALL_OUT,
	CLIPPED_EASY,
	CLIPPED_HARD
} point_result_t;

typedef struct
{
	unsigned int
		a_in : 1,
		b_in : 1,
		c_in : 1,
		reserved : 29;
} inside_bit_t;

typedef union
{
	inside_bit_t bit;
	unsigned int dword;
} inside_t;

int intersect_triangle_plane(const plane_t &p, const vertex_t &a, const vertex_t &b, const 	vertex_t &c, vertex_t *result);

#endif
