#include "shader.h"

int GlobalShader::init(Graphics *gfx)
{
	if (Shader::init(gfx, "shader.vs", NULL, "shader.fs"))
	{
		program_handle = -1;
		return -1;
	}

	matrix = glGetUniformLocation(program_handle, "mvp");
	u_color = glGetUniformLocation(program_handle, "color");

	return 0;
}

void GlobalShader::prelink()
{
#ifndef DIRECTX
	glBindAttribLocation(program_handle, 0, "attr_position");
	glBindAttribLocation(program_handle, 1, "attr_TexCoord");
//	glBindAttribLocation(program_handle, 2, "attr_LightCoord");
//	glBindAttribLocation(program_handle, 3, "attr_normal");
	glBindAttribLocation(program_handle, 4, "attr_color");
//	glBindAttribLocation(program_handle, 5, "attr_tangent");
#endif
}


void GlobalShader::Params(matrix4 &mvp, vec3 color)
{
#ifdef DIRECTX
	uniform->SetMatrix(gfx->device, "mvp", (D3DXMATRIX *)mvp.m);
	uniform->SetFloatArray(gfx->device, "u_position", (float *)position, num_lights);
	uniform->SetFloatArray(gfx->device, "u_color", (float *)color, num_lights);
	uniform->SetInt(gfx->device, "u_num_lights", num_lights);
#else
	glUniformMatrix4fv(matrix, 1, GL_FALSE, mvp.m);
	glUniform3f(u_color, color.x, color.y, color.z);
#endif
}
